#include "xsmodmsk.h"

static char strData[] = "STUFF.DAT";
static char strMask[] = "STATUS.MSK";
static char strSign[] = "KenSilverman";
/* max width: 1600 */
static WORD maskdata[1600];
static WORD masksize;

/* actually "STATUS.MSK" can be here as static array but since anyone
   can mod it - take the actual version from the "STUFF.DAT" file */
void ReadBuildMask(WORD width, int state) {
grp_item item;
DWORD i, sz, fsz;
int fl;
  switch (state) {
    /* read mask */
    case 0:
      masksize = 0;
      fl = open(strData, O_RDONLY | O_BINARY);
      if (fl != -1) {
        lseek(fl, 0, SEEK_END);
        fsz = tell(fl);
        lseek(fl, 0, SEEK_SET);
        /* sanity check */
        if (fsz >= sizeof(item)) {
          read(fl, &item, sizeof(item));
          /* header size */
          sz = (item.size + 1) * sizeof(item);
          /* some more sanity checks */
          if (MatchItem(item.name, strSign) && (sz <= fsz)) {
            for (i = item.size; i; i--) {
              read(fl, &item, sizeof(item));
              /* found * few more sanity checks */
              if (MatchItem(item.name, strMask) && (item.size >= 4) && ((sz + item.size) <= fsz)) {
                /* go to file */
                lseek(fl, sz, SEEK_SET);
                /* mask size */
                read(fl, &masksize, 2);
                /* unused */
                read(fl, &fsz, 2);
                /* max size */
                sz = (item.size - 4);
                if (masksize > sz) {
                  masksize = sz;
                }
                /* size in bytes => elements count */
                masksize /= 2;
                if (masksize > 1600) {
                  masksize = 1600;
                }
                /* read mask */
                read(fl, &maskdata[0], masksize * 2);
                break;
              }
              /* calc absolute item offset */
              sz += item.size;
            }
          }
        }
        close(fl);
      }
      break;
    /* build mask */
    case 1:
      if (masksize) {
        fl = open(strMask, O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
        if (fl != -1) {
          i = width*2;
          /* size */
          write(fl, &i, 2);
          /* unused */
          i = 0;
          write(fl, &i, 2);
          /* multiply by 1000 to avoid float coeffs */
          sz = width;
          sz = (sz * 1000) / masksize; /* (width * 1000) / 320 */
          /* extend mask */
          for (i = 0; i < width; i++) {
            write(fl, &maskdata[(size_t) ((i * 1000) / sz)], 2);
          }
          close(fl);
        }
      }
      break;
    /* delete mask */
    case 2:
      if (FileExists(strMask, 0)) {
        remove(strMask);
      }
      break;
  }
}

WORD MaskStatus(void) {
  return(masksize);
}
